#ifndef VERSION
#define VERSION "Version 0.3"
#endif

#ifdef GNOME
	#ifndef GNOME_H
	#include <gnome.h>
	#endif
#else
	#include <gtk/gtk.h>
#endif

#define MESSAGE_ERR     0
#define MESSAGE_NORMAL  1
#define MESSAGE_ANSI    2
#define MESSAGE_NONE    3

#define bool int:1

struct bmud_history{
	gchar **list;	/* the actual history */
	gchar *tmp;	/* in case something was typed before traverssing hist */
	int size;	/* current number of elements */
	int pos;	/* where to add */
	int cur;	/* which is displayed */
	int max;	/* total number of elements :) */
	int cyclic;	/* controls cyclic vs linear history */
};

typedef struct {
	GtkWidget *window, *menu, *text, *stat, *ent, *hostentry, *portentry, *vbox;

	GdkFont *disp_font;
	gchar *disp_font_name;
	GdkColor curr_color;

	struct bmud_history *hist;

	gint lines;
	gint maxlines;
}bmud;

extern bmud *mud;
extern GtkWidget *spawn_gui( void );
extern void textfield_add( gchar *, int);
extern void cbox(void);
extern void clear(int,GtkText *);
extern void cleartail();
extern void do_alias(char *);
extern void show_map(void);
extern void show_wiz(void);
extern void show_eq(void);
extern void show_fontsel(void);
extern void show_colorm(void);

extern void init(int, char **);
extern void do_menu(GtkWidget *);
extern void do_about();
extern void destructify();

extern void hist_add(char *);
extern gint hist_evt(GtkWidget*,GdkEventKey*,gpointer);
extern void hist_clear();

extern void init_colors();
extern void disp_ansi(int, gchar *, GtkWidget *);
extern void disconnect ( void );
extern void make_connection ( char *host, char *port );
extern void open_connection (  const char *host, const char *port );
extern void send_to_connection ( GtkWidget *, gpointer data );
extern void read_from_connection (gpointer, gint , GdkInputCondition );

extern GdkColor color_white;
extern GdkColor color_black;
extern GdkColor color_blue;
extern GdkColor color_green;
extern GdkColor color_red;
extern GdkColor color_brown;
extern GdkColor color_purple;
extern GdkColor color_orange;
extern GdkColor color_yellow;
extern GdkColor color_lightgreen;
extern GdkColor color_cyan;
extern GdkColor color_lightcyan;
extern GdkColor color_lightblue;
extern GdkColor color_pink;
extern GdkColor color_grey;
extern GdkColor color_lightgrey;
extern GdkColor *foreground;

