#include "bmud.h"
#include <gdk/gdkkeysyms.h>

void hist_add(char *x){
	if(mud->hist->max<1)return;
		/* free up 'lost' bit */
	g_free(mud->hist->list[mud->hist->pos]);
		/* add our line to the history */
	mud->hist->list[mud->hist->pos]=g_strdup(x);
		/* update the rest of history */
	mud->hist->cur=mud->hist->pos;
	if(mud->hist->size<mud->hist->max)mud->hist->size++;
	mud->hist->pos=(mud->hist->pos+1)%mud->hist->size;

	g_free(mud->hist->tmp);
	mud->hist->cur=mud->hist->pos;
	}

void hist_prev(){
	if(mud->hist->cyclic==1)
		if((mud->hist->pos+1)%mud->hist->size==mud->hist->cur)  return;
	g_free(mud->hist->list[mud->hist->cur]);
	mud->hist->list[mud->hist->cur] = 
		g_strdup(gtk_entry_get_text(GTK_ENTRY(mud->ent)));
	if(mud->hist->size>0){
		mud->hist->cur--;
		if (mud->hist->cur<0)mud->hist->cur=mud->hist->size-1;
		}
	gtk_entry_set_text(GTK_ENTRY(mud->ent),mud->hist->list[mud->hist->cur]);
	}

void hist_next(){
	if(mud->hist->cyclic==1)
		if(mud->hist->cur==mud->hist->pos)return;
	mud->hist->list[mud->hist->cur] = 
		g_strdup(gtk_entry_get_text(GTK_ENTRY(mud->ent)));
	if(mud->hist->size)
		mud->hist->cur = (mud->hist->cur+1)%mud->hist->size;
	gtk_entry_set_text(GTK_ENTRY(mud->ent),mud->hist->list[mud->hist->cur]);
	}

void hist_clear(){
	int x;
	for(x=0;x<mud->hist->max;x++)g_free(mud->hist->list[x]);
	mud->hist->cur=mud->hist->pos=0;
	}

gint hist_evt(GtkWidget* w, GdkEventKey* event, gpointer data){
	switch(event->keyval){
		case GDK_Up:{
			hist_prev();
			break;}
		case GDK_Down:{
			hist_next();
			break;}
		case GDK_Page_Up:{
			GtkAdjustment *adj=GTK_TEXT(mud->text)->vadj;
			gtk_adjustment_set_value(adj,adj->value-adj->page_size);
			break;}
		case GDK_Page_Down:{
			GtkAdjustment *adj=GTK_TEXT(mud->text)->vadj;
			if(adj->value < adj->upper - adj->page_size)
				gtk_adjustment_set_value(adj,adj->value+adj->page_size);
			break;}
		default:
			/* normal handling */
			return 0;
			break;
		}
	gtk_signal_emit_stop_by_name(GTK_OBJECT(w), "key_press_event");
	return 1;
}
